def myabs(a):
    if a < 0:
        return -a
    else:
        return a


def mymanhattan(p1, p2):
    sum = 0
    for i in range(len(p1)):
        sum += myabs(p1[i] - p2[i])
    return sum


def myhamming(p1, p2):
    sum = 0
    for i in range(len(p1)):
        if p1[i] != p2[i]:
            sum += 1
    return sum


def myeuclidean(p1, p2):
    sum = 0
    for i in range(len(p1)):
        sum += (p1[i] - p2[i])**2
    return sum**0.5


def nearestneighbor(p, community, df):
    nn = community[0][0]
    nnd = df(p, community[0][1])
    if len(community) > 1:
        for neighbor in community:
            d = df(p, neighbor[1])
            if d < nnd:
                nn = neighbor[0]
                nnd = d
    return nn

if __name__ == '__main__':
    triangle = [
        ["top", [0, 1]],
        ["bottom-left", [0, 0]],
        ["bottom-right", [2, 0]],
    ]

    print()
    print("triangle:", triangle)
    print()
    print("nearestneighbor([0, 0.6], triangle, myeuclidean) =", nearestneighbor([0, 0.6], triangle, myeuclidean))
    print("nearestneighbor([0, 0.4], triangle, myeuclidean) =", nearestneighbor([0, 0.4], triangle, myeuclidean))
    print()
    print()

    x = float(input("Enter x-coordinate: "))
    y = float(input("Enter y-coordinate: "))

    print("nearestneighbor([{}, {}], triangle, myeuclidean) =".format(x, y), nearestneighbor([x, y], triangle, myeuclidean))
    print("nearestneighbor([{}, {}], triangle, mymanhattan) =".format(x, y), nearestneighbor([x, y], triangle, mymanhattan))
    print("nearestneighbor([{}, {}], triangle, myhamming) =".format(x, y), nearestneighbor([x, y], triangle, myhamming))
